Problem
LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.
Rules and restrictions:
You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday.
The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flightsi = 0; Otherwise, flightsi = 1. Also, flightsi = 0 for all i.
You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week"s Monday morning. Since flight time is so short, we don"t consider the impact of flight time.
For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days representing this relationship. For the value of daysi, it represents the maximum days you could take vacation in the city i in the week j.
You"re given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.
Example 1:
Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]] Output: 12 Explanation: Ans = 6 + 3 + 3 = 12. One of the best strategies is: 1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day. (Although you start at city 0, we could also fly to and start at other cities since it is Monday.) 2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days. 3rd week : stay at city 2, and play 3 days and work 4 days.
Example 2:
Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]] Output: 3 Explanation: Ans = 1 + 1 + 1 = 3. Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks. For each week, you only have one day to play and six days to work. So the maximum number of vacation days is 3.
Example 3:
Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]] Output: 21 Explanation: Ans = 7 + 7 + 7 = 21 One of the best strategies is: 1st week : stay at city 0, and play 7 days. 2nd week : fly from city 0 to city 1 on Monday, and play 7 days. 3rd week : fly from city 1 to city 2 on Monday, and play 7 days.
Note:
N and K are positive integers, which are in the range of [1, 100]. In the matrix flights, all the values are integers in the range of [0, 1]. In the matrix days, all the values are integers in the range [0, 7]. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won"t be counted as vacation days. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week. We don"t consider the impact of flight hours towards the calculation of vacation days.Solution
class Solution { public int maxVacationDays(int[][] flights, int[][] days) { //n cities, k weeks //flights[i][j] == 1 means there"s a flight from i to j //days[i][j] means the j-th week max vacation in city i //dp[i][j] means the max vacation to in city i in week j int n = flights.length; int k = days[0].length; int[][] dp = new int[n][k]; for (int i = 0; i < n; i++) { Arrays.fill(dp[i], -1); } dp[0][0] = days[0][0]; for (int i = 1; i < n; i++) { if (flights[0][i] == 1) { dp[i][0] = days[i][0]; } } for (int week = 1; week < k; week++) { for (int dest = 0; dest < n; dest++) { for (int depart = 0; depart < n; depart++) { if (dp[depart][week-1] != -1 && (depart == dest || flights[depart][dest] == 1)) { dp[dest][week] = Math.max(dp[dest][week], dp[depart][week-1]+days[dest][week]); } } } } int res = 0; for (int city = 0; city < n; city++) { res = Math.max(res, dp[city][k-1]); } return res; } }
文章版權歸作者所有,未經允許請勿轉載,若此文章存在違規行為,您可以聯系管理員刪除。
轉載請注明本文地址:http://specialneedsforspecialkids.com/yun/72113.html
摘要:切片語句的表達式切片字符串是包含的不會取簡稱顧頭不顧尾國慶節快樂定義變量取的第一個字符到第個字符取的第二個字符到第個字符超出范圍了是不會報錯的切片和索引超出范圍是不一樣的索引會報錯切片不會。 一、標識符 1、標識符包括:變量、項目名、包名(文件夾)、...
Problem Given a non-empty array of integers, return the third maximum number in this array. If it does not exist, return the maximum number. The time complexity must be in O(n). Example Example 1: Inp...
Problem Given an integer array with no duplicates. A maximum tree building on this array is defined as follow: The root is the maximum number in the array.The left subtree is the maximum tree construc...
LeetCode 104 Maximum Depth of Binary Tree難度:Easy 題目描述:找到一顆二叉樹的最深深度。Given a binary tree, find its maximum depth. The maximum depth is the number of nodes along the longest path from the root node down ...
閱讀 1698·2023-04-26 01:02
閱讀 4841·2021-11-24 09:39
閱讀 1803·2019-08-30 15:44
閱讀 2872·2019-08-30 11:10
閱讀 1783·2019-08-30 10:49
閱讀 984·2019-08-29 17:06
閱讀 609·2019-08-29 16:15
閱讀 902·2019-08-29 15:17